package cn.wustlinghang.wusthelper.internal.library.bean;

import cn.wustlinghang.mywust.core.request.service.auth.LibraryLogin;
import cn.wustlinghang.mywust.core.request.service.auth.UndergraduateLogin;
import cn.wustlinghang.mywust.core.request.service.library.LibraryApiService;
import cn.wustlinghang.mywust.core.request.service.undergraduate.*;
import cn.wustlinghang.mywust.network.RequestClientOption;
import cn.wustlinghang.mywust.network.Requester;
import cn.wustlinghang.mywust.network.okhttp.SimpleOkhttpRequester;
import jakarta.inject.Singleton;

public class MywustRequestAgentBeans {

    @Singleton
    public RequestClientOption requestClientOption() {
        RequestClientOption.Proxy proxy = RequestClientOption.Proxy.builder()
                .address("127.0.0.1")
                .port(8080)
                .build();
        RequestClientOption option = new RequestClientOption();
//        option.setProxy(proxy);

        return option;
    }

    @Singleton
    public Requester requester(RequestClientOption option) {
        return new SimpleOkhttpRequester(option, true);
    }

    @Singleton
    public LibraryLogin libraryLogin(Requester requester) {
        return new LibraryLogin(requester);
    }

    @Singleton
    public LibraryApiService libraryApiService(Requester requester) {
        return new LibraryApiService(requester);
    }
}