package cn.wustlinghang.wusthelper.internal.undergrad.api.http;

import cn.wustlinghang.mywust.data.global.Course;
import cn.wustlinghang.wusthelper.internal.undergrad.services.ParseService;
import cn.wustlinghang.wusthelper.internal.undergrad.services.RequestAgentService;
import cn.wustlinghang.wusthelper.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.util.List;

@Path("/course_table")
@ApplicationScoped
public class CourseTableApi {
    private final RequestAgentService agentService;
    private final ParseService parseService;

    public CourseTableApi(RequestAgentService agentService,
                          ParseService parseService) {
        this.agentService = agentService;
        this.parseService = parseService;
    }

    @GET
    @Path("/")
    public List<Course> get(@QueryParam("cookie") @NotNull String cookie,
                            @QueryParam("term") String term)
            throws RpcException {
        return this.parse(this.agent(cookie, term));
    }

    @GET
    @Path("/agent")
    public String agent(@QueryParam("cookie") @NotNull String cookie,
                        @QueryParam("term") String term)
            throws RpcException {
        return agentService.getCourseTable(cookie, term);
    }

    @POST
    @Path("/parse")
    public List<Course> parse(String html) throws RpcException {
        return parseService.parseCourseTable(html);
    }
}
